﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Eco.Shared.Math;
 
    [RepairRequiresSkill(typeof(AdvancedSmeltingSkill), 2)] 
    public partial class ModernHoeRecipe :
        RecipeFamily
    {
        public ModernHoeRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "ModernHoe",
                    Localizer.DoStr("Modern Hoe"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(ModernHoeHeadItem), 1, true),
               new IngredientElement(typeof(ModernHandleItem), 1, true),
                    },
                new CraftingElement<ModernHoeItem>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(250); 
            this.CraftMinutes = CreateCraftTimeValue(0.5f);    
            this.Initialize(Localizer.DoStr("Modern Hoe"), typeof(ModernHoeRecipe));
            CraftingComponent.AddRecipe(typeof(ToolBenchObject), this);
        }
    }

    [Serialized]
    [LocDisplayName("Modern Hoe")]
    [Tier(4)] 
    [Weight(1000)]
    [Category("Tool")]
    [Tag("Tool", 1)]
    [Ecopedia("Items", "Tools", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]                    
    public partial class ModernHoeItem : HoeItem
    {
        // Static values
        private static IDynamicValue caloriesBurn = new MultiDynamicValue(MultiDynamicOps.Multiply, new TalentModifiedValue(typeof(ModernHoeItem), typeof(ToolEfficiencyTalent)), CreateCalorieValue(10, typeof(FarmingSkill), typeof(ModernHoeItem)));
        private static IDynamicValue exp = new ConstantValue(0.1f);
        private static IDynamicValue tier = new ConstantValue(4);
        private static IDynamicValue skilledRepairCost = new ConstantValue(1);

        private static Vector2i[] areaBlocks = new Vector2i[]
        {
        new Vector2i(0, 1), 
        new Vector2i(0, 2), 
        };

        // Tool overrides

        public override IDynamicValue CaloriesBurn      => caloriesBurn;
        public override Type ExperienceSkill            => typeof(FarmingSkill);
        public override IDynamicValue ExperienceRate    => exp;
        public override IDynamicValue Tier              => tier;
        public override IDynamicValue SkilledRepairCost => skilledRepairCost;
        public override float DurabilityRate            => DurabilityMax / 1500f;
        public override Item RepairItem => RandomUtil.CoinToss() ? Get<ModernHoeHeadItem>() : Get<ModernHandleItem>();
        public override int FullRepairAmount => 1;
        public override Vector2i[] AreaBlocks           => areaBlocks;
    }
}
