﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Eco.Shared.Math;

    public partial class StoneAxeRecipe :
        RecipeFamily
    {
        public StoneAxeRecipe()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "StoneAxe",
                    Localizer.DoStr("Stone Axe"),
                    new IngredientElement[]
                    {
               new IngredientElement(typeof(StoneAxeHeadItem), 1, true),
               new IngredientElement(typeof(PrimitiveWoodHandleItem), 1, true),
                    },
                new CraftingElement<StoneAxeItem>()
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(10); 
            this.CraftMinutes = CreateCraftTimeValue(0.5f);
            this.Initialize(Localizer.DoStr("Stone Axe"), typeof(StoneAxeRecipe));
            CraftingComponent.AddRecipe(typeof(ToolBenchObject), this);
        }
    }

    [Serialized]
    [LocDisplayName("Stone Axe")]
    [Tier(1)] 
    [Weight(1000)]
    [Category("Tool")]
    [Tag("Tool", 1)]
    [Ecopedia("Items", "Tools", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]                    
    public partial class StoneAxeItem : AxeItem
    {
        // Static values
        private static IDynamicValue caloriesBurn = new MultiDynamicValue(MultiDynamicOps.Multiply, new TalentModifiedValue(typeof(StoneAxeItem), typeof(LoggingToolEfficiencyTalent)), CreateCalorieValue(20, typeof(LoggingSkill), typeof(StoneAxeItem)));
        private static IDynamicValue damage = CreateDamageValue(1, typeof(LoggingSkill), typeof(StoneAxeItem)); 
        private static IDynamicValue exp = new ConstantValue(0.1f);
        private static IDynamicValue tier = new MultiDynamicValue(MultiDynamicOps.Sum, new ConstantValue(1), new TalentModifiedValue(typeof(StoneAxeItem), typeof(LoggingToolStrengthTalent), 0));
        private static IDynamicValue skilledRepairCost = new ConstantValue(1);  
        

        // Tool overrides

        public override IDynamicValue CaloriesBurn      => caloriesBurn;
        public override IDynamicValue Damage            => damage; 
        public override Type ExperienceSkill            => typeof(LoggingSkill);
        public override IDynamicValue ExperienceRate    => exp;
        public override IDynamicValue Tier              => tier;
        public override IDynamicValue SkilledRepairCost => skilledRepairCost;
        public override float DurabilityRate            => DurabilityMax / 250f;
        public override Item RepairItem => RandomUtil.CoinToss() ? Get<StoneAxeHeadItem>() : Get<PrimitiveWoodHandleItem>();
        public override int FullRepairAmount => 1;
    }
}
